<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('welcome');
});

//user
Route::get("createUser", "UserController@CreateUser");
Route::get("modifyUser", "UserController@ModifyUser");
Route::get("deleteUser", "UserController@DeleteUser");
Route::get("listUser", "UserController@ListUser");

// role
Route::get("admin/createRole", "RoleController@CreateRole");
Route::get("admin/modifyRole", "RoleController@ModifyRole");
Route::get("admin/deleteRole", "RoleController@DeleteRole");
Route::get("admin/listRole", "RoleController@ListRole");

Route::get("admin/loadRoleActionBars", "PermissionController@LoadRoleActionBars");


Route::get("loadRole", "RoleController@LoadRole");


// user role
Route::get("admin/assignRoleUser", "PermissionController@AssignRoleUser");
Route::get("admin/loadRoleUsers", "RoleController@LoadRoleUsers");

// user action bar
Route::get("admin/assignActionBars", "PermissionController@AssignActionBars");
Route::get("admin/assignUserRole", "PermissionController@AssignUserRole");

Route::get("addUserActionBar", "UserActionBarController@AddUserActionBar");
Route::get("removeUserActionBar", "UserActionBarController@RemoveUserActionBar");

// group
Route::get("createGroup", "GroupController@CreateGroup");
Route::get("modifyGroup", "GroupController@ModifyGroup");
Route::get("deleteGroup", "GroupController@DeleteGroup");

// group user
Route::get("groupAddUser", "GroupUserController@GroupAddUser");
Route::get("groupRemoveUser", "GroupUserController@GroupRemoveUser");

Route::get("grantPrivilege", "PermissionController@GrantPrivilege");

// action bar
Route::get("admin/addActionBar", "ActionBarController@AddActionBar");
Route::get("admin/modifyActionBar", "ActionBarController@ModifyActionBar");
Route::get("admin/deleteActionBar", "ActionBarController@DeleteActionBar");
Route::get("admin/loadActionBar", "ActionBarController@LoadActionBar");
